// file      : xsd-frontend/traversal/enumeration.cxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#include <xsd-frontend/traversal/enumeration.hxx>

namespace XSDFrontend
{
  namespace Traversal
  {
    // Enumeration
    //
    Void Enumeration::
    traverse (Type& s)
    {
      pre (s);
      name (s);
      names (s);
      post (s);
    }

    Void Enumeration::
    pre (Type&)
    {
    }

    Void Enumeration::
    name (Type&)
    {
    }

    Void Enumeration::
    post (Type&)
    {
    }


    // Enumerator
    //
    Void Enumerator::
    traverse (Type& a)
    {
      pre (a);
      belongs (a);
      name (a);
      post (a);
    }

    Void Enumerator::
    pre (Type&)
    {
    }

    Void Enumerator::
    belongs (Type& a, EdgeDispatcherBase& d)
    {
      d.dispatch (a.belongs ());
    }

    Void Enumerator::
    belongs (Type& a)
    {
      belongs (a, edge_traverser ());
    }

    Void Enumerator::
    name (Type&)
    {
    }

    Void Enumerator::
    post (Type&)
    {
    }
  }
}
